//+------------------------------------------------------------------+
//|                                          Martingale outliers.mq4 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

extern double initial_lot_size=0.01;
extern int SL=50,TP=50,Candle_size=30;
extern int consec_losses=7;

double lots=0.01;
string lossarray[100],lossarray2[100];
double price;
int j=0,k=0,N;
int ticket;
bool buyloss=false,sellloss=false,initial=true,buyprofit=false,sellprofit=false,trade1,trade2;



//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
price= iClose(Symbol(),0,0) ;
N=consec_losses;
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()

{ if (iClose(Symbol(),0,0)>iClose(Symbol(),0,1)+Candle_size*Point){
   //initial
  if(initial==true){
    if (iClose(Symbol(),0,0)< price - SL*Point ){ buyloss=true; price= iClose(Symbol(),0,0) ;}
    if (iClose(Symbol(),0,0)> price + SL*Point ){ sellloss=true; price= iClose(Symbol(),0,0) ;}
    
    if (iClose(Symbol(),0,0)> price + TP*Point ){ buyprofit=true;}
    if (iClose(Symbol(),0,0)> price + TP*Point ){ sellprofit=true;}
    
    if (sellloss==true){ lossarray[k]="sell";   k++; sellloss=false;}
    if (buyloss==true){ lossarray[k]="buy";   k++; buyloss=false;}
    
    if (k==N){ initial=false;
    for (int i=0;i<=N;i++){ lossarray2[i]=lossarray[i]; }}
    }//end initial
    
    //rest of program
    if (initial==false){ 
    
    //array updates
     if (iClose(Symbol(),0,0)< price - SL*Point ){ buyloss=true;price= iClose(Symbol(),0,0) ;}
    if (iClose(Symbol(),0,0)> price + SL*Point ){ sellloss=true;price= iClose(Symbol(),0,0) ;}
    
     
     if (sellloss==true){ for (int i=0;i<N;i++){ 
     lossarray[i]=lossarray[i+1];}
     
     lossarray[N]="sell";  sellloss=false;}
     
     
    if (buyloss==true){ for (int i=0;i<N;i++){ 
    lossarray[i]=lossarray[i+1];}
    
    lossarray[N]="buy";  buyloss=false;}
    
    
    
    //trade
    if(OrdersTotal()<1){ OrderSelect(ticket,SELECT_BY_TICKET);
                        if(OrderProfit()<0){lots=lots*2;j++; if (j==N+1){j=0;}};
                        if(OrderProfit()>=0){lots=initial_lot_size; j=0; trade1=true;trade2=true;  for (int i=0;i<=N;i++){ lossarray2[i]=lossarray[i];
                        if(lossarray[i]!="buy"){trade1=false; }
                        if(lossarray[i]!="sell"){trade2=false; }}}
                        
                        if (trade1==true || trade2==true) {
    
                        if (lossarray2[j]=="sell"){ ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,2,Ask+SL*Point,Ask-TP*Point,NULL);}
                        if (lossarray2[j]=="buy"){ ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,2,Bid-SL*Point,Bid+TP*Point,NULL);}
                        }
    }
    }
    
   }
  }
//+------------------------------------------------------------------+
